<template>
  <div v-if="presentation_hierarchy">
    <q-card class="q-pb-md" flat :key="language_switch">
      <q-card-section role="heading"
                      class="text-primary presentation_hierarchy__heading text-weight-bold"
                      v-html="show_label(presentation_hierarchy[0])">
      </q-card-section>
      <q-tree ref="tree" :nodes="presentation_hierarchy" node-key="rowid" default-expand-all role="tree"
              color="primary">
        <template v-slot:default-header="row">
          <q-item class="row tree_item"
                  clickable
                  dense
                  role="treeitem"
                  @click.stop
                  @keypress.enter.stop
                  @click="nodeClicked(row.node)"
                  :class="{active: current===row.node.rowid}"
                  :id="row.node.rowid">
            <div class="col-10" v-html="show_label(row.node)"></div>
            <q-item-label class="col" v-if="row.node.preferred_label">{{ label_nice_role(row.node) }}</q-item-label>
          </q-item>
        </template>
      </q-tree>
    </q-card>
  </div>

</template>

<script>
import SharedMethods from "components/SharedMethods";

export default {
  name: "PresentationHierarchyTree",
  created() {
    this.label_nice_role = SharedMethods.label_nice_role
    this.get_label = SharedMethods.get_label
    this.show_label = SharedMethods.show_label
  },
  emits: ['nodeClicked'],
  props: {
    presentation_hierarchy: undefined
  },
  data() {
    return {
      language_switch: undefined,
      current: undefined
    }
  },
  watch: {
    presentation_hierarchy: function () {
      this.$nextTick(() => {
        this.$refs.tree.expandAll()
      })
    },
    "$route.query.lang": function () {
      this.language_switch = this.$route.query.lang
    }

  },
  methods: {
    nodeClicked: function (node) {
      this.node = node
      this.$emit('nodeClicked', node)
      this.current = node.rowid
      this.$nextTick(() => {
      })
    }
  }
}
</script>

<style scoped lang="scss">
.active_node {
  background-color: $list_selected_bg;
  color: white;
}

.active {
  background-color: $detail_bg;
}

.tree_item {
  width: 95%;
}

.presentation_hierarchy__heading {
  border-bottom: 1px solid $primary;
  font-size: 20px;
  margin-bottom: 10px;
}

</style>
